MapExtension.Messenger.AvailableVersion = MapExtensionAddon.toc.Version
MapExtension.Messenger.IgnoreList = {}
MapExtension.Messenger.QueueTimer = Inspect.Time.Real()

MapExtension.Messenger.Send = function(identifier, data)
	if type(data) == "table" then data = MapExtension.Utils.Serialize(data, "") end
	MapExtension.Messenger.toSend = { identifier = identifier, data = data }
	MapExtension.Messenger.QueueTimer = Inspect.Time.Real()
	Command.Message.Broadcast("guild", nil, identifier, data, MapExtension.Messenger.SendCallback)
end

MapExtension.Messenger.SendCallback = function(failure, message)
	if failure == false or failure == nil then MapExtension.Messenger.toSend = nil end
end

MapExtension.Messenger.SendQueue = function()
	if Inspect.System.Watchdog() > 0.1 and Inspect.Time.Real() - MapExtension.Messenger.QueueTimer > 1 and MapExtension.Messenger.toSend ~= nil then
		MapExtension.Messenger.QueueTimer = Inspect.Time.Real()
		Command.Message.Broadcast("guild", nil, MapExtension.Messenger.toSend.identifier, MapExtension.Messenger.toSend.data, MapExtension.Messenger.SendCallback)
	end
end

MapExtension.Messenger.Receive = function(handle, from, type, channel, identifier, data)
	if identifier == MapExtension.Messenger.MessageVersion then
		if MapExtension.Messenger.ParseVersion(data) > MapExtension.Messenger.ParseVersion(MapExtension.Messenger.AvailableVersion) then
			MapExtension.Messenger.AvailableVersion = data
			if MapExtensionUISettings.options.checkVersion then
				Command.Console.Display("general", true, "<font color=\"#AD48FB\">" .. MapExtension.Language.Messenger1[MapExtension.AE.Language] .. MapExtensionAddon.name .. MapExtension.Language.Messenger2[MapExtension.AE.Language] .. MapExtensionAddon.toc.Version .. MapExtension.Language.Messenger3[MapExtension.AE.Language] .. data .. "</font>", true)
			end
		end
	end

	if identifier == MapExtension.Messenger.MessageRare then
		data = MapExtension.Utils.Deserialize(data)
		if MapExtension.Messenger.IgnoreList[data.id] ~= true and MapExtensionUISettings.options.rareNotification == true and (MapExtension.Achievement.Rare.List[data.name] == false or MapExtensionUISettings.options.rareFilter ~= true) then
			Command.Console.Display("general", true, "<font color=\"#AD48FB\">" .. iif(data.player == Inspect.Unit.Detail("player").name, MapExtension.Language.Messenger4[MapExtension.AE.Language], data.player)  .. MapExtension.Language.Messenger5[MapExtension.AE.Language] .. data.name .. MapExtension.Language.Messenger6[MapExtension.AE.Language] .. data.x .. ", " .. data.y .. " (" .. data.zone .. iif(data.shard == nil, "", MapExtension.Language.Messenger6[MapExtension.AE.Language] .. (data.shard or "")) .. ")</font>", true)
			MapExtension.Messenger.IgnoreList[data.id] = true
		end
	end
end

MapExtension.Messenger.ParseVersion = function(data)
	local i1, i2, high, mid, low = string.find(data, "(%d+).(%d+).(%d+)")
	high = tonumber(high) or 0
	mid = tonumber(mid) or 0
	low = tonumber(low) or 0
	return high * 10000 + mid * 100 + low
end