function MapExtension.Tooltip.Init(parent)
	MapExtension.Tooltip.window = MapExtension.GUI.CreateFrame(parent, "CENTER", 0, 0, 320, 100, 100)
	MapExtension.Tooltip.window:SetVisible(false)

	MapExtension.GUI.CreateSimpleTexture(MapExtension.Tooltip.window, 0, 0, 320, 12, 0, "img/tooltip320-top.png", "TOPLEFT")
	MapExtension.GUI.CreateSimpleTexture(MapExtension.Tooltip.window, 0, 0, 320, 26, 0, "img/tooltip320-bottom.png", "BOTTOMLEFT")
	MapExtension.Tooltip.background = MapExtension.GUI.CreateSimpleTexture(MapExtension.Tooltip.window, 0, 12, 320, 50, 0, "img/tooltip320-middle.png", "TOPLEFT")
	MapExtension.GUI.CreateSimpleTexture(MapExtension.Tooltip.background, 5, 30, 320, 5, 0, "img/tooltip-separator.png", "TOPLEFT")

	MapExtension.GUI.CreateText(MapExtension.Tooltip.background, "TOPLEFT", 20, 40, MapExtension.Language.Location[MapExtension.AE.Language])
	MapExtension.Tooltip.fields = {
		text = MapExtension.GUI.CreateText(MapExtension.Tooltip.background, "TOPLEFT", 20, 3),
		name = MapExtension.GUI.CreateText(MapExtension.Tooltip.background, "TOPLEFT", 20, 3, "", nil, 16, { 1, 0.8, 0.2, 1 }),
		type = MapExtension.GUI.CreateText(MapExtension.Tooltip.background, "TOPRIGHT", -20, 5),
		location = MapExtension.GUI.CreateText(MapExtension.Tooltip.background, "TOPRIGHT", -20, 40),
		descrl = MapExtension.GUI.CreateText(MapExtension.Tooltip.background, "TOPLEFT", 20, 62, "", nil, nil, { 1, 0.8, 0.4, 1 }),
		descrr = MapExtension.GUI.CreateText(MapExtension.Tooltip.background, "TOPRIGHT", -20, 62, "", nil, nil, { 1, 0.8, 0.4, 1 })
	}
end

function MapExtension.Tooltip.Show(id, parent)
	local height = iif(parent.data.descrl == nil and parent.data.descrr == nil, 102, 124)
	MapExtension.Tooltip.id = id

	if parent.data.list == nil then
		MapExtension.Tooltip.fields.text:SetText("")
		MapExtension.Tooltip.fields.name:SetText(parent.data.caption)
		MapExtension.Tooltip.fields.type:SetText(parent.data.type)
		MapExtension.Tooltip.fields.location:SetText(math.floor(parent.position.x) .. ", " .. math.floor(parent.position.y))
		MapExtension.Tooltip.fields.descrl:SetText(parent.data.descrl or "")
		MapExtension.Tooltip.fields.descrr:SetText(parent.data.descrr or "")
	else
		local text = ""
		for k, v in pairs(parent.data.list) do
			if parent.data.translate ~= nil then k = parent.data.translate[k] end
			text = text .. k .. ", "
		end
		MapExtension.Tooltip.fields.text:SetText(string.sub(text, 1, string.len(text) - 2))
		MapExtension.Tooltip.fields.name:SetText("")
		MapExtension.Tooltip.fields.type:SetText("")
		MapExtension.Tooltip.fields.location:SetText(math.floor(parent.position.x) .. ", " .. math.floor(parent.position.y))
		MapExtension.Tooltip.fields.descrl:SetText("")
		MapExtension.Tooltip.fields.descrr:SetText("")		
	end

	MapExtension.Tooltip.window:SetHeight(height)
	MapExtension.Tooltip.background:SetHeight(height - 38)
	MapExtension.Tooltip.window:SetPoint("CENTER", parent, "CENTERRIGHT", MapExtension.Tooltip.window:GetWidth() / 2, 0)
	MapExtension.Tooltip.window:SetVisible(true)
end

function MapExtension.Tooltip.Hide(id)
	if MapExtension.Tooltip.id == id or id == nil then
		MapExtension.Tooltip.window:SetVisible(false)
	end
end